## libde265 1.0.11

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3.2)

project (libde265
    LANGUAGES C CXX
    VERSION 1.0.11
)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# The version number.
set (NUMERIC_VERSION 0x01001100)
set (PACKAGE_VERSION ${PROJECT_VERSION})

include (${CMAKE_ROOT}/Modules/CheckCCompilerFlag.cmake)
include (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)

include(GNUInstallDirs)
include(CheckFunctionExists)

option(ENABLE_SDL "Enable SDL" ON)

if (ENABLE_SDL)
	find_package(SDL)
endif()

find_package(Threads REQUIRED)

CHECK_INCLUDE_FILE(malloc.h HAVE_MALLOC_H)
CHECK_FUNCTION_EXISTS(posix_memalign HAVE_POSIX_MEMALIGN)

if (HAVE_MALLOC_H)
  add_definitions(-DHAVE_MALLOC_H)
endif()
if (HAVE_POSIX_MEMALIGN)
  add_definitions(-DHAVE_POSIX_MEMALIGN)
endif()

configure_file (libde265/de265-version.h.in libde265/de265-version.h)

if(CMAKE_COMPILER_IS_GNUCXX OR ${CMAKE_CXX_COMPILER_ID} MATCHES Clang)
  add_definitions(-Wall)
endif()

option(DISABLE_SSE "Disable SSE optimizations" OFF)

option(BUILD_SHARED_LIBS "Build shared library" ON)
if(NOT BUILD_SHARED_LIBS)
  add_definitions(-DLIBDE265_STATIC_BUILD)
endif()

include_directories ("${PROJECT_SOURCE_DIR}")
include_directories ("${PROJECT_BINARY_DIR}")
include_directories ("${PROJECT_SOURCE_DIR}/libde265")
if(MSVC)
  include_directories ("${PROJECT_SOURCE_DIR}/extra")
endif()

option(ENABLE_DECODER "Enable Decoder" ON)
option(ENABLE_ENCODER "Enable Encoder" OFF)

add_subdirectory (libde265)
if (ENABLE_DECODER)
  add_subdirectory (dec265)
endif()
if (ENABLE_ENCODER)
  add_subdirectory (enc265)
endif()

=== debian/changelog ===
libde265 (1.0.11-1+deb12u2) bookworm; urgency=medium

  * Non-maintainer upload by the LTS Team.
    (Closes: #1059275)
  * CVE-2023-49465
    heap-buffer-overflow in derive_spatial_luma_vector_prediction()
  * CVE-2023-49467
    heap-buffer-overflow in derive_combined_bipredictive_merging_candidates()
  * CVE-2023-49468
    global buffer overflow in read_coding_unit()

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 29 Dec 2023 23:03:02 +0100

libde265 (1.0.11-1+deb12u1) bookworm; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * CVE-2023-27102 (Closes: #1033257)
    fix segmentation violation in the
    function decoder_context::process_slice_segment_header
  * CVE-2023-27103
    fix heap buffer overflow in the
    function derive_collocated_motion_vectors
  * CVE-2023-43887
    fix buffer over-read in pic_parameter_set::dump
  * CVE-2023-47471 (Closes: #1056187)
    fix buffer overflow in the slice_segment_header function

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 26 Nov 2023 13:03:02 +0100

libde265 (1.0.11-1) unstable; urgency=medium

  [ Tobias Frost ]
  * Make my patch less noisy.

  [ Joachim Bauch ]
  * New upstream version 1.0.11
  * Unpackaged upstream version 1.0.10 fixes the following CVEs, most caused
    by the same underlying issue:
    CVE-2020-21594, CVE-2020-21595, CVE-2020-21596, CVE-2020-21597,
    CVE-2020-21598, CVE-2020-21599, CVE-2020-21600, CVE-2020-21601,
    CVE-2020-21602, CVE-2020-21603, CVE-2020-21604, CVE-2020-21605,
    CVE-2020-21606, CVE-2022-1253, CVE-2022-43236, CVE-2022-43237,
    CVE-2022-43238, CVE-2022-43239, CVE-2022-43240, CVE-2022-43241,
    CVE-2022-43242, CVE-2022-43243, CVE-2022-43244, CVE-2022-43245,
    CVE-2022-43248, CVE-2022-43249, CVE-2022-43250, CVE-2022-43252,
    CVE-2022-43253, CVE-2022-47655
  * Remove patch applied upstream.
  * Update patches for new upstream version.
  * Remove copyright entry for file no longer present in upstream.
  * Update symbols for new upstream version.
  * Bump "Standards-Version" to 4.6.2

 -- Joachim Bauch <bauch@struktur.de>  Thu, 02 Feb 2023 16:06:20 +0100

libde265 (1.0.9-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patches to mitigate asan failures:
    reject_reference_pics_from_different_sps.patch and
    use_sps_from_the_image.patch.
  * Combined, this two patches fixes:
    - CVE-2022-43243, CVE-2022-43248, CVE-2022-43253 (Closes: #1025816)
    - CVE-2022-43235, CVE-2022-43236, CVE-2022-43237, CVE-2022-43238,
      CVE-2022-43239, CVE-2022-43240, CVE-2022-43241, CVE-2022-43242,
      CVE-2022-43244, CVE-2022-43250, CVE-2022-43252 (Closes: #1027179)
    - CVE-2022-47655
  * Additional patch recycle_sps_if_possible.patch to avoid over-rejecting
    valid video streams due to reject_reference_pics_from_different_sps.patch.
  * Modifying past changelog entries to indicate when vulnerabilities were
    fixed:
    - In 1.0.9-1, in total 11 CVE's. see #1004963 and #1014999
    - In 1.0.3-1, 1 CVE, see #1029396
  * drop unused Build-Depends: libjpeg-dev, libpng-dev and libxv-dev
    (Closes: #981260)

 -- Tobias Frost <tobi@debian.org>  Sun, 22 Jan 2023 13:19:20 +0100

=== debian/control ===
Source: libde265
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Joachim Bauch <bauch@struktur.de>
Build-Depends:
 debhelper-compat (= 13),
 qtbase5-dev | libqt4-dev,
 libsdl-dev,
 libswscale-dev,
 libx11-dev,
 libxext-dev,
 pkg-config
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/strukturag/libde265
Vcs-Git: https://salsa.debian.org/multimedia-team/libde265.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libde265

Package: libde265-0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Open H.265 video codec implementation
 libde265 is an open source implementation of the H.265 video codec.
 It is written from scratch in plain C for simplicity and efficiency.
 Its simple API makes it easy to integrate it into other software.

Package: libde265-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends:
 libde265-0 (= ${binary:Version}),
 ${misc:Depends}
Description: Open H.265 video codec implementation - development files
 libde265 is an open source implementation of the H.265 video codec.
 It is written from scratch in plain C for simplicity and efficiency.
 Its simple API makes it easy to integrate it into other software.
 .
 The development headers for compiling programs that use libde265
 are provided by this package.

Package: libde265-examples
Section: video
Architecture: any
Depends:
 libde265-0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Open H.265 video codec implementation - examples
 libde265 is an open source implementation of the H.265 video codec.
 It is written from scratch in plain C for simplicity and efficiency.
 Its simple API makes it easy to integrate it into other software.
 .
 Sample applications using libde265 are provided by this package.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	cd $(CURDIR)/debian/tmp/usr/bin/ && mv dec265 libde265-dec265
	if [ -e "$(CURDIR)/debian/tmp/usr/bin/sherlock265" ]; then \
		cd $(CURDIR)/debian/tmp/usr/bin/ && mv sherlock265 \
			libde265-sherlock265; \
	fi

## libde265 1.0.11.1

=== dec265/CMakeLists.txt ===
add_executable (dec265 dec265.cc)

target_link_libraries (dec265 PRIVATE de265)

if(SDL_FOUND)
  target_sources(dec265 PRIVATE sdl.cc)
  target_compile_definitions(dec265 PRIVATE HAVE_SDL)
  target_include_directories (dec265 PRIVATE "${SDL_INCLUDE_DIR}")
  target_link_libraries (dec265 PRIVATE ${SDL_LIBRARY})
endif()

if(MSVC)
  target_sources(dec265 PRIVATE 
    ../extra/getopt.c
    ../extra/getopt_long.c
  )
endif()

install (TARGETS dec265 DESTINATION ${CMAKE_INSTALL_BINDIR})

if(NOT MSVC)
  # hdrcopy uses internal APIs that are not available when compiled for Windows
  add_executable (hdrcopy hdrcopy.cc)

  target_link_libraries (hdrcopy PRIVATE de265)

  install (TARGETS hdrcopy DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== libde265/CMakeLists.txt ===
include(CMakePackageConfigHelpers)

set (libde265_sources 
  alloc_pool.cc
  bitstream.cc
  cabac.cc
  configparam.cc
  contextmodel.cc
  de265.cc
  deblock.cc
  decctx.cc
  dpb.cc
  en265.cc
  fallback-dct.cc
  fallback-motion.cc 
  fallback.cc
  image-io.cc
  image.cc
  intrapred.cc
  md5.cc
  motion.cc
  nal-parser.cc
  nal.cc
  pps.cc
  quality.cc
  refpic.cc
  sao.cc
  scan.cc
  sei.cc
  slice.cc
  sps.cc
  threads.cc
  transform.cc
  util.cc
  visualize.cc
  vps.cc
  vui.cc
)

set (libde265_headers
  acceleration.h
  alloc_pool.h
  bitstream.h
  cabac.h
  configparam.h
  de265-version.h
  contextmodel.h
  de265.h
  deblock.h
  decctx.h
  dpb.h
  en265.h
  fallback-dct.h
  fallback-motion.h
  fallback.h
  image-io.h
  image.h
  intrapred.h
  md5.h
  motion.h
  nal-parser.h
  nal.h
  pps.h
  quality.h
  refpic.h
  sao.h
  scan.h
  sei.h
  slice.h
  sps.h
  threads.h
  transform.h
  util.h
  visualize.h
  vps.h
  vui.h
)

set (libde265_public_headers
  de265.h
  en265.h
  ${CMAKE_CURRENT_BINARY_DIR}/de265-version.h
)

if(MSVC OR MINGW)
  set (libde265_sources
    ${libde265_sources}
    ../extra/win32cond.c
    ../extra/win32cond.h
  )
endif()

add_definitions(-DLIBDE265_EXPORTS)

add_subdirectory (encoder)

if(NOT DISABLE_SSE)
  if (MSVC)
    set(SUPPORTS_SSE2 1)
    set(SUPPORTS_SSSE3 1)
    set(SUPPORTS_SSE4_1 1)
  else (MSVC)
    check_c_compiler_flag(-msse2 SUPPORTS_SSE2)
    check_c_compiler_flag(-mssse3 SUPPORTS_SSSE3)
    check_c_compiler_flag(-msse4.1 SUPPORTS_SSE4_1)
  endif (MSVC)

  if(SUPPORTS_SSE4_1)
    add_definitions(-DHAVE_SSE4_1)
  endif()
  if(SUPPORTS_SSE4_1 OR (SUPPORTS_SSE2 AND SUPPORTS_SSSE3))
    add_subdirectory (x86)
  endif()
endif()

add_library(de265 ${libde265_sources} ${ENCODER_OBJECTS} ${X86_OBJECTS})
target_link_libraries(de265 PRIVATE Threads::Threads)
target_include_directories(de265 PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR})

write_basic_package_version_file(libde265ConfigVersion.cmake COMPATIBILITY ExactVersion)

install(TARGETS de265 EXPORT libde265Config
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${libde265_public_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libde265)
install(EXPORT libde265Config DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/libde265")

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libde265ConfigVersion.cmake DESTINATION
    "${CMAKE_INSTALL_LIBDIR}/cmake/libde265")


# --- pkg-config

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
    set(libdir "${CMAKE_INSTALL_LIBDIR}")
else()
    set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
endif()
if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
    set(includedir "${CMAKE_INSTALL_INCLUDEDIR}")
else()
    set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
endif()

configure_file(../libde265.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libde265.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libde265.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
libde265 (1.0.11.1-deepin1) unstable; urgency=medium

  * 更新libde265版本到1.0.11-0+deb10u4，修复CVE安全漏洞
    CVE-2023-24751, CVE-2023-24752, CVE-2023-24754, CVE-2023-24755,
    CVE-2023-24756, CVE-2023-24757, CVE-2023-24758 and CVE-2023-25221.

 -- zengwei <zengwei1@uniontech.com>  Mon, 06 Mar 2023 14:27:03 +0800

libde265 (1.0.11-0+deb10u4) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * Import new upstream version, based on the 1.0.11-0+deb11u1 package
    from bullseye.
    - fixing:
      CVE-2023-24751, CVE-2023-24752, CVE-2023-24754, CVE-2023-24755,
      CVE-2023-24756, CVE-2023-24757, CVE-2023-24758 and CVE-2023-25221.
    - dropping no longer needed patches that have been integrated or
      made obsolete by the new upstream version.

 -- Tobias Frost <tobi@debian.org>  Sat, 04 Mar 2023 17:01:58 +0100

libde265 (1.0.3-1+deb10u3) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * Source-only upload. (Last upload was accidentially a binary-upload)

 -- Tobias Frost <tobi@debian.org>  Tue, 24 Jan 2023 22:39:16 +0100

libde265 (1.0.3-1+deb10u2) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * Add patches:
    - reject_reference_pics_from_different_sps.patch
    - use_sps_from_the_image.patch
    - recycle_sps_if_possible.patch
  * Cherry-pick additional patches from upstream:
    check-4-negative-Q-value.patch
    CVE-2022-43245-fix-asan-wildpointer-apply_sao_internal.patch
  * Add patch "fix-invalid-memory-access.patch" to avoid out-of-bound
    array access leading to crashes.
  * Add patch CVE-2020-21596-global-buffer-overflow.patch
  * Add patch to avoid use-after-free problems.
  * Cumulative, the patches are fixing:
    CVE-2020-21596, CVE-2020-21597, CVE-2020-21598, CVE-2022-43235,
    CVE-2022-43236, CVE-2022-43237, CVE-2022-43238, CVE-2022-43239,
    CVE-2022-43240, CVE-2022-43241, CVE-2022-43242, CVE-2022-43243,
    CVE-2022-43244, CVE-2022-43245, CVE-2022-43248, CVE-2022-43249,
    CVE-2022-43250, CVE-2022-43252, CVE-2022-43253, CVE-2022-47655.
    (Closes: #1029357, #1029397, #1025816, #1027179)
   * Amend changelog of 1.0.3-1+deb10u1, as it turned out that the
     fix for CVE 2020-51999 and CVE 2021-36408 fixed other issues too.

 -- Tobias Frost <tobi@debian.org>  Tue, 24 Jan 2023 21:42:47 +0100

libde265 (1.0.3-1+deb10u1) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * Cherry-pick upstream patches for:
    - CVE-2020-21599 (Closes #1014999)
    - CVE-2021-35452, CVE-2021-36408, CVE-2021-36409, CVE-2021-36410 and
      CVE-2021-36411 (Closes: #1014977)
  * The fix for CVE-2020-21599 also fixed:
    CVE-2020-21595, CVE-2020-21600, CVE-2020-21601, CVE-2020-21602,
    CVE-2020-21603, CVE-2020-21604, CVE-2020-21605, CVE-2020-21606
  * The fix for CVE-2021-36408 also fixed:
    CVE-2020-21597, CVE-2020-21598. (Closes: #1004963)

 -- Tobias Frost <tobi@debian.org>  Thu, 15 Dec 2022 17:40:12 +0100

=== debian/rules ===
--- 
+++ 
@@ -13,3 +13,6 @@
 		cd $(CURDIR)/debian/tmp/usr/bin/ && mv sherlock265 \
 			libde265-sherlock265; \
 	fi
+
+override_dh_strip:
+	dh_strip --ddeb-migration='libde265-dbg (<< 1.0.2-2~)'

## libde265 1.0.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project (libde265
     LANGUAGES C CXX
-    VERSION 1.0.11
+    VERSION 1.0.12
 )
 
 set(CMAKE_CXX_STANDARD 11)
@@ -11,7 +11,7 @@
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 # The version number.
-set (NUMERIC_VERSION 0x01001100)
+set (NUMERIC_VERSION 0x01001200)
 set (PACKAGE_VERSION ${PROJECT_VERSION})
 
 include (${CMAKE_ROOT}/Modules/CheckCCompilerFlag.cmake)

=== libde265/CMakeLists.txt ===
--- 
+++ 
@@ -119,6 +119,10 @@
 
 write_basic_package_version_file(libde265ConfigVersion.cmake COMPATIBILITY ExactVersion)
 
+if (WIN32)
+    set_target_properties(de265 PROPERTIES PREFIX "lib")
+endif()
+
 install(TARGETS de265 EXPORT libde265Config
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
@@ -147,5 +151,6 @@
     set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
 endif()
 
+set(VERSION ${PROJECT_VERSION}) # so that the replacement in libde265.pc will work with both autotools and CMake
 configure_file(../libde265.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libde265.pc @ONLY)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libde265.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
libde265 (1.0.12-2ubuntu0.2) mantic-security; urgency=medium

  * SECURITY UPDATE: denial of service
    - debian/patches/CVE-2023-51792.patch: check validity of conformance
      window parameters.
    - CVE-2023-51792

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Mon, 06 May 2024 21:17:15 +0200

libde265 (1.0.12-2ubuntu0.1) mantic-security; urgency=medium

  * SECURITY UPDATE: buffer overflow
    - debian/patches/CVE-2023-43887.patch: fix buffer overflow via the
      num_tile_columns and num_tile_row parameters in the function
      pic_parameter_set::dump.
    - CVE-2023-43887
  * SECURITY UPDATE: buffer overflow
    - debian/patches/CVE-2023-47471.patch: check for null-pointer in
      functon slice_segment_header::dump_slice_segment_header.
    - CVE-2023-47471
  * SECURITY UPDATE: heap-buffer-overflow
    - debian/patches/CVE-2023-49465.patch: fix buffer overflow via the
      derive_spatial_luma_vector_prediction function.
    - CVE-2023-49465
  * SECURITY UPDATE: heap-buffer-overflow
    - debian/patches/CVE-2023-49467.patch: prevent endless loop in
      decode_ref_idx_lX function when numRefIdxLXActive is invalid.
    - CVE-2023-49467
  * SECURITY UPDATE: buffer overflow
    - debian/patches/CVE-2023-49468.patch: sanitize values if IPM is
      uninitialized in get_IntraPredMode function.
    - CVE-2023-49468

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Fri, 01 Mar 2024 10:32:46 +0100

libde265 (1.0.12-2) unstable; urgency=medium

  * Team upload
  * Clean Makefiles (Closes: #1047354)

  [ Vladimir Petko ]
  * add libde265 decoder smoke test (Closes: #1052214)

 -- Bastian Germann <bage@debian.org>  Tue, 19 Sep 2023 08:20:11 +0000

libde265 (1.0.12-1) unstable; urgency=medium

  * New upstream version 1.0.12
  * Fixes CVE-2023-27102, CVE-2023-27103

 -- Joachim Bauch <bauch@struktur.de>  Tue, 20 Jun 2023 09:10:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libde265
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  Joachim Bauch <bauch@struktur.de>

## libde265 1.0.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project (libde265
     LANGUAGES C CXX
-    VERSION 1.0.12
+    VERSION 1.0.15
 )
 
 set(CMAKE_CXX_STANDARD 11)
@@ -11,7 +11,7 @@
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 # The version number.
-set (NUMERIC_VERSION 0x01001200)
+set (NUMERIC_VERSION 0x01001500)
 set (PACKAGE_VERSION ${PROJECT_VERSION})
 
 include (${CMAKE_ROOT}/Modules/CheckCCompilerFlag.cmake)
@@ -23,7 +23,7 @@
 option(ENABLE_SDL "Enable SDL" ON)
 
 if (ENABLE_SDL)
-	find_package(SDL)
+	find_package(SDL2)
 endif()
 
 find_package(Threads REQUIRED)
@@ -44,7 +44,13 @@
   add_definitions(-Wall)
 endif()
 
-option(DISABLE_SSE "Disable SSE optimizations" OFF)
+include(CheckCXXSymbolExists)
+check_cxx_symbol_exists(_LIBCPP_VERSION cstdlib HAVE_LIBCPP)
+if(HAVE_LIBCPP)
+  set(LIBS_PRIVATE "-lc++")
+else()
+  set(LIBS_PRIVATE "-lstdc++")
+endif()
 
 option(BUILD_SHARED_LIBS "Build shared library" ON)
 if(NOT BUILD_SHARED_LIBS)

=== libde265/CMakeLists.txt ===
--- 
+++ 
@@ -94,7 +94,15 @@
 
 add_subdirectory (encoder)
 
-if(NOT DISABLE_SSE)
+check_c_source_compiles(
+  "#if !defined(__x86_64) && !defined(__i386__) \
+  && !defined(_M_IX86) && !defined(_M_AMD64)
+  #error not x86
+  #endif
+  int main(){return 0;}"
+  HAVE_X86)
+
+if(HAVE_X86)
   if (MSVC)
     set(SUPPORTS_SSE2 1)
     set(SUPPORTS_SSSE3 1)

=== libde265/encoder/algo/CMakeLists.txt ===
set (algo_sources
  algo.h algo.cc
  coding-options.h coding-options.cc
  ctb-qscale.h ctb-qscale.cc
  cb-split.h cb-split.cc
  cb-intrapartmode.h cb-intrapartmode.cc
  cb-interpartmode.h cb-interpartmode.cc
  cb-skip.h cb-skip.cc
  cb-intra-inter.h cb-intra-inter.cc
  cb-mergeindex.h cb-mergeindex.cc
  tb-split.h tb-split.cc
  tb-transform.h tb-transform.cc
  tb-intrapredmode.h tb-intrapredmode.cc
  tb-rateestim.h tb-rateestim.cc
  pb-mv.h pb-mv.cc
)

add_library(algo OBJECT ${algo_sources})
set(ALGO_OBJECTS $<TARGET_OBJECTS:algo> PARENT_SCOPE)

=== debian/changelog ===
libde265 (1.0.15-1build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 20:09:53 +0100

libde265 (1.0.15-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:46:41 +0000

libde265 (1.0.15-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:34:33 +0000

libde265 (1.0.15-1) unstable; urgency=medium

  * New upstream version 1.0.15
  * Fixes CVE-2023-49465, CVE-2023-49467, CVE-2023-49468.
  * Add patch to fix "Libs.private" in libde265.pc.

 -- Joachim Bauch <bauch@struktur.de>  Thu, 21 Dec 2023 09:29:24 +0100

libde265 (1.0.13-1) unstable; urgency=medium

  * New upstream version 1.0.13
  * Fixes CVE-2023-47471 (Closes: #1056187), CVE-2023-43887.
  * Update patches for new upstream version.
  * d/control: Upstream switched examples to SDL2 (Closes: #1038097).
  * Update symbols for new upstream version.

 -- Joachim Bauch <bauch@struktur.de>  Tue, 21 Nov 2023 08:59:09 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  qtbase5-dev | libqt4-dev,
- libsdl-dev,
+ libsdl2-dev,
  libswscale-dev,
  libx11-dev,
  libxext-dev,

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,11 @@
 %:
 	dh $@
 
+
+override_dh_auto_test:
+	./debian/tests/test-decode
+	dh_auto_test
+
 override_dh_auto_install:
 	dh_auto_install
 	cd $(CURDIR)/debian/tmp/usr/bin/ && mv dec265 libde265-dec265
@@ -13,6 +18,3 @@
 		cd $(CURDIR)/debian/tmp/usr/bin/ && mv sherlock265 \
 			libde265-sherlock265; \
 	fi
-
-override_dh_strip:
-	dh_strip --ddeb-migration='libde265-dbg (<< 1.0.2-2~)'

## libde265 1.0.16

=== dec265/CMakeLists.txt ===
add_executable (dec265 dec265.cc)

target_link_libraries (dec265 PRIVATE de265)

if(SDL2_FOUND)
  target_sources(dec265 PRIVATE sdl.cc)
  target_compile_definitions(dec265 PRIVATE HAVE_SDL)
  target_include_directories (dec265 PRIVATE "${SDL2_INCLUDE_DIRS}")
  target_link_libraries (dec265 PRIVATE ${SDL2_LIBRARIES})
endif()

if(MSVC)
  target_sources(dec265 PRIVATE
    ../extra/getopt.c
    ../extra/getopt_long.c
  )
endif()

install (TARGETS dec265 DESTINATION ${CMAKE_INSTALL_BINDIR})

#if(NOT MSVC)
#  # hdrcopy uses internal APIs that are not available when compiled for Windows
#  add_executable (hdrcopy hdrcopy.cc)
#
#  target_link_libraries (hdrcopy PRIVATE de265)
#
#  install (TARGETS hdrcopy DESTINATION ${CMAKE_INSTALL_BINDIR})
#endif()

=== libde265/CMakeLists.txt ===
--- 
+++ 
@@ -121,20 +121,60 @@
   endif()
 endif()
 
-add_library(de265 ${libde265_sources} ${ENCODER_OBJECTS} ${X86_OBJECTS})
+add_library(de265 ${libde265_sources} ${libde265_public_headers} ${ENCODER_OBJECTS} ${X86_OBJECTS})
 target_link_libraries(de265 PRIVATE Threads::Threads)
 target_include_directories(de265 PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR})
 
 write_basic_package_version_file(libde265ConfigVersion.cmake COMPATIBILITY ExactVersion)
 
+# --- debug output
+
+set(LOG_LEVELS error info debug trace)
+set(DE265_LOG_LEVEL "error" CACHE STRING "Log level (${LOG_LEVELS})")
+
+set_property(CACHE DE265_LOG_LEVEL PROPERTY STRINGS ${LOG_LEVELS})
+if (NOT DE265_LOG_LEVEL IN_LIST LOG_LEVELS)
+    message(FATAL_ERROR "DE265_LOG_LEVEL has to be one of: ${LOG_LEVELS}")
+endif ()
+
+if (DE265_LOG_LEVEL MATCHES "error")
+    target_compile_definitions(de265 PRIVATE DE265_LOG_ERROR)
+elseif (DE265_LOG_LEVEL MATCHES "info")
+    target_compile_definitions(de265 PRIVATE DE265_LOG_ERROR DE265_LOG_INFO)
+elseif (DE265_LOG_LEVEL MATCHES "debug")
+    target_compile_definitions(de265 PRIVATE DE265_LOG_ERROR DE265_LOG_INFO DE265_LOG_DEBUG)
+elseif (DE265_LOG_LEVEL MATCHES "trace")
+    target_compile_definitions(de265 PRIVATE DE265_LOG_ERROR DE265_LOG_INFO DE265_LOG_DEBUG DE265_LOG_TRACE)
+endif()
+
+
 if (WIN32)
     set_target_properties(de265 PROPERTIES PREFIX "lib")
+endif()
+
+if (BUILD_FRAMEWORK) 
+  set_target_properties(de265 PROPERTIES
+    FRAMEWORK TRUE
+    FRAMEWORK_VERSION "${PROJECT_VERSION}"
+    PRODUCT_BUNDLE_IDENTIFIER "github.com/strukturag/libde265"
+    XCODE_ATTRIBUTE_INSTALL_PATH "@rpath"
+    # OUTPUT_NAME "de265"
+    XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ""
+    XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED "NO"
+    XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED "NO"
+    PUBLIC_HEADER "${libde265_public_headers}"
+    MACOSX_FRAMEWORK_IDENTIFIER "github.com/strukturag/libde265"
+    MACOSX_FRAMEWORK_BUNDLE_VERSION "${PROJECT_VERSION}"
+    MACOSX_RPATH TRUE)
 endif()
 
 install(TARGETS de265 EXPORT libde265Config
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    FRAMEWORK DESTINATION Library/Frameworks COMPONENT runtime OPTIONAL
+    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
+    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libde265
 )
 
 install(FILES ${libde265_public_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libde265)

=== debian/changelog ===
libde265 (1.0.16-1) unstable; urgency=medium

  * d/control: Change "Uploaders" to use my @debian.org address.
  * New upstream version 1.0.16
  * Refresh patches for new upstream version.
  * d/control: Migrate from "pkg-config" to "pkgconf".
  * Bump "Standards-Version" to 4.7.2
  * d/copyright: Remove entry for file no longer present in upstream tarball.
  * Ignore internal std:: symbol.
  * d/rules: Check "DEB_BUILD_OPTIONS" before running tests.

 -- Joachim Bauch <fancycode@debian.org>  Tue, 13 May 2025 09:32:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: libde265
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
- Joachim Bauch <bauch@struktur.de>
+ Joachim Bauch <fancycode@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  qtbase5-dev | libqt4-dev,
@@ -13,9 +12,9 @@
  libswscale-dev,
  libx11-dev,
  libxext-dev,
- pkg-config
+ pkgconf
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/strukturag/libde265
 Vcs-Git: https://salsa.debian.org/multimedia-team/libde265.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/libde265

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,9 @@
 
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	./debian/tests/test-decode
+endif
 	dh_auto_test
 
 override_dh_auto_install:
